#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 2007;
bool visited[MAX_N][MAX_N];

int main() {
    int n, d, k;
    cin >> n >> d >> k;
    for (int i = 0; i < MAX_N; i++) {
        for (int j = 0; j < MAX_N; j++) {
            visited[i][j] = 0;
        }
    }
    int x = 1000, y = 1000, nn = n;
    vector <pair <int, int>> path;
    path.push_back({x, y});
    int add_x = 0, add_y = 1;
    while (n > 0) {
        for (int i = 0; i < d; i++) {
            x += add_x;
            y += add_y;
            path.push_back({x, y});
        }
        int mem = add_x;
        add_x = -add_y;
        add_y = mem;
        for (int i = 0; i < d; i++) {
            x += add_x;
            y += add_y;
            path.push_back({x, y});
        }
        n -= 2 * d;
        mem = add_x;
        add_x = -add_y;
        add_y = mem;
        d *= k;
    }
    n = nn;
    int mini_x = MAX_N, mini_y = MAX_N, maxi_x = -1, maxi_y = -1;
    for (int i = 0; i <= n; i++) {
        visited[path[i].first][path[i].second] = 1;
        mini_x = min(mini_x, path[i].first);
        maxi_x = max(maxi_x, path[i].first);
        mini_y = min(mini_y, path[i].second);
        maxi_y = max(maxi_y, path[i].second);
    }
    cout << maxi_x - mini_x + 1 << ' ' << maxi_y - mini_y + 1 << endl;
    for (int i = mini_x; i <= maxi_x; i++) {
        for (int j = mini_y; j <= maxi_y; j++) {
            if (visited[i][j]) cout << "*";
            else cout << ".";
        }
        cout << endl;
    }
    return 0;
}
