#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1007;
bool used[MAX_N];
int perm[MAX_N];
int n, t;

bool gen(int pos) {
    if (pos == n) {
        for (int i = 0; i < n; i++) {
            cout << perm[i] << ' ';
        }
        cout << '\n';
        t--;
        return (t == 0);
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i] && pos + 1 != i) {
            used[i] = 1;
            perm[pos] = i;
            if (gen(pos + 1)) return 1;
            used[i] = 0;
        }
    }
    return 0;
}

int main() {
    cin >> n >> t;
    for (int i = 1; i <= n; i++) used[i] = 0;
    gen(0);
    return 0;
}
