#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include "math.h"

using namespace std;
typedef unsigned long long ull;

int main()
{
    int n, k;
    cin >> n >> k;

    ull t;
    vector<ull> v;

    for (int i = 0; i < n; i++)
    {
        cin >> t;
        v.push_back(t);
    }

    int maxnod = 1;

    ull max_ull = pow(10, 18);
    for (int ptr = 0; ptr <= n - k; ptr++)
    {
        ull min_el = max_ull;
        for (int i = ptr; i < ptr + k; i++)
        {
            if (v[i] < min_el)
                min_el = v[i];
        }
        //cout << "min: " << min_el << endl;
        // min value in subarray is the maximum possible NOD
        // (although it may not be the NOD)
        if (min_el < maxnod)
            continue;

        int mb_nod = min_el;
        for (; mb_nod > 1; mb_nod/=2)
        {
            bool isnod = true;
            for (int i = ptr; i < ptr + k; i++)
            {
                if (v[i] % mb_nod != 0)
                {
                    isnod = false;
                    break;
                }
            }
            if (isnod)
            {
                if (maxnod < mb_nod)
                    maxnod = mb_nod;
                break; // go check another subarray
            }
        }
        //cout << maxnod << " ";
    }
    cout << maxnod << endl;

    return 0;
}
