//package Municipal;

import java.util.ArrayList;
import java.util.Scanner;

public class TaskE {
    static long gcd(long a, long b){
        while (a!=0 && b!=0){
            if(a>b){
                a%=b;
            }
            else{
                b%=a;
            }
        }
        return a+b;
    }
    private static class Interval{
        int l, r;
        long v;
        Interval(int l, int r, long v){
            this.l=l;
            this.r=r;
            this.v=v;
        }
    }
    public static void main(String[] args) {
        Scanner scn = new Scanner(System.in);
        int n = scn.nextInt();
        int k = scn.nextInt();
        long[] a = new long[n];
        for(int i = 0; i<n; i++){
            a[i]=scn.nextLong();
        }
        ArrayList<Interval> list = new ArrayList<>();
        int d = (int)Math.sqrt(n);
        int ind = 0;
        for(int i = 0; i<d; i++){
            list.add(new Interval(ind, ind+d-1, -1));
            ind+=d;
        }
        if(ind<n){
            list.add(new Interval(ind, n-1, -1));
        }
        for(int i = 0; i<list.size(); i++){
            long v = a[list.get(i).l];
            for(int  j = list.get(i).l; j<=list.get(i).r; j++){
                v=gcd(v, a[j]);
            }
            list.get(i).v=v;
        }
        int leftInd = 0, rightInd=0;
        while (rightInd<list.size() && list.get(rightInd).r<k){
            rightInd++;
        }
        rightInd--;
        long max = 0;
        for(int i = 0; i<=n-k; i++){
            int r = i+k-1;
            if(rightInd<list.size()-1 && list.get(rightInd+1).r<=r){
                rightInd++;
            }
            if(i>list.get(leftInd).l && leftInd<list.size()-1){
                leftInd++;
            }
            long gcd;
            if(leftInd<=rightInd && i<=list.get(leftInd).l && r>=list.get(rightInd).r) {
                gcd = list.get(leftInd).v;
                for (int j = leftInd + 1; j <= rightInd; j++) {
                    gcd = gcd(gcd, list.get(j).v);
                }
            }
            else{
                gcd=a[i];
            }
            for(int j = i; j<=Math.min(r,list.get(leftInd).l); j++){
                gcd = gcd(gcd, a[j]);
            }
            if(rightInd<0){
                for(int j = i; j<=r; j++){
                    gcd=gcd(gcd, a[j]);
                }
            }
            else {
                for (int j = Math.max(i, list.get(rightInd).r); j <= r; j++) {
                    gcd = gcd(gcd, a[j]);
                }
            }
            max=Math.max(max, gcd);
        }
        System.out.println(max);
    }
}
