import java.util.Scanner;

enum Dir {
    U, R, D, L
}

public class Main {
    public static void main(String[] args) {
        Scanner cin = new Scanner(System.in);

        int n = cin.nextInt(), dStart = cin.nextInt(), k = cin.nextInt();
        int d = dStart;

        int x = 0, y = 0, xmin = 0, xmax = 0, ymin = 0, ymax = 0;
        Dir dir = Dir.R;

        for (int i = 0; i < n; i++) {

            for (int step = 0; step < d && i < n; step++) {
                i ++;
                switch (dir) {
                    case U:
                        y++;
                        break;
                    case R:
                        x++;
                        break;
                    case D:
                        y--;
                        break;
                    case L:
                        x--;
                        break;
                }
            }

            if (xmax < x) xmax = x;
            if (xmin > x) xmin = x;
            if (ymax < y) ymax = y;
            if (ymin > y) ymin = y;

            switch (dir) {
                case U:
                    dir = Dir.L;
                    break;
                case R:
                    dir = Dir.U;
                    break;
                case D:
                    dir = Dir.R;
                    break;
                case L:
                    dir = Dir.D;
                    break;
            }

            for (int step = 0; step < d && i < n; step++) {
                i ++;
                switch (dir) {
                    case U:
                        y++;
                        break;
                    case R:
                        x++;
                        break;
                    case D:
                        y--;
                        break;
                    case L:
                        x--;
                        break;
                }
            }

            if (xmax < x) xmax = x;
            if (xmin > x) xmin = x;
            if (ymax < y) ymax = y;
            if (ymin > y) ymin = y;


            switch (dir) {
                case U:
                    dir = Dir.L;
                    break;
                case R:
                    dir = Dir.U;
                    break;
                case D:
                    dir = Dir.R;
                    break;
                case L:
                    dir = Dir.D;
                    break;
            }

            d *= k;
        }

//        System.out.println(xmin + " " + xmax + " " + ymin + " " + ymax);

        int height = Math.abs(ymax - ymin) + 1;
        int width = Math.abs(xmax - xmin) + 1;

        char[][] field = new char[height][width];

        for (int i = 0; i < height; i++) {
            for (int j = 0; j < width; j++) {
                field[i][j] = '.';
            }
        }

        field[Math.abs(ymax)][Math.abs(xmax)] ='*';

        dir = Dir.R;
        d = dStart;
        x = y = 0;

        for (int i = 0; i <= n + 1; i++) {

            for (int step = 0; step < d && i <= n + 1; step++) {
                i ++;
                switch (dir) {
                    case U:
                        y++;
                        break;
                    case R:
                        x++;
                        break;
                    case D:
                        y--;
                        break;
                    case L:
                        x--;
                        break;
                }
                field[Math.abs(ymax) - y][Math.abs(xmax) + x] = '*';

//                System.out.println("\n\n " + x + " " + y );
//                for (int l = 0; l < height; l++) {
//                    for (int j = 0; j < width; j++) {
//                        System.out.print(field[l][j]);
//                    }
//                    System.out.println();
//                }
//                System.out.println();
            }

            switch (dir) {
                case U:
                    dir = Dir.L;
                    break;
                case R:
                    dir = Dir.U;
                    break;
                case D:
                    dir = Dir.R;
                    break;
                case L:
                    dir = Dir.D;
                    break;
            }

            for (int step = 0; step < d && i <= n + 1; step++) {
                i ++;
                switch (dir) {
                    case U:
                        y++;
                        break;
                    case R:
                        x++;
                        break;
                    case D:
                        y--;
                        break;
                    case L:
                        x--;
                        break;
                }

                field[Math.abs(ymax) - y][Math.abs(xmax) + x] = '*';

//                System.out.println("\n\n " +  x + " " + y );
//                for (int l = 0; l < height; l++) {
//                    for (int j = 0; j < width; j++) {
//                        System.out.print(field[l][j]);
//                    }
//                    System.out.println();
//                }
//                System.out.println();
            }

            switch (dir) {
                case U:
                    dir = Dir.L;
                    break;
                case R:
                    dir = Dir.U;
                    break;
                case D:
                    dir = Dir.R;
                    break;
                case L:
                    dir = Dir.D;
                    break;
            }

            d *= k;
        }

        System.out.println(width + " " + height);

        for (int i = 0; i < height; i++) {
            for (int j = 0; j < width; j++) {
                System.out.print(field[i][j]);
            }
            System.out.println();
        }
    }
}
