#include <iostream>
#include <vector>

using namespace std;

unsigned long long min(unsigned long long a, unsigned long long b) {
	return a > b ? b : a;
}

unsigned long long _NOD(unsigned long long a, unsigned long long b) {
	while (a % b != 0 && b % a != 0) {
		if (a > b) {
			a -= b;
		}
		else {
			b -= a;
		}
	}
	return min(a, b);
}

unsigned long long NOD(vector<unsigned long long> &a, unsigned from, unsigned to) {
	unsigned long long n = a[to];
	for (size_t i = from; i < to; ++i) {
		n = _NOD(a[i], n);
	}
	return n;
}

int main(int argc, char* argv[])
{
	unsigned n, k;
	cin >> n >> k;
	vector<unsigned long long> a(n);
	for (auto &e : a) {
		cin >> e;
	}

	unsigned long long max = 0;
	for (size_t i = 0; i <= n - k; ++i) {
		auto b = NOD(a, i, i + k - 1);
		if (b > max) max = b;
	}

	cout << max;


	return 0;
}