﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication2
{
    class Cell
    {
        public int x, y;
        public Cell(int _x, int _y)
        {
            x = _x;
            y = _y;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            int curX = 0,
                curY = 0;
            string[] s = Console.ReadLine().Split(' ');
            int n = int.Parse(s[0]);
            int d = int.Parse(s[1]);
            int k = int.Parse(s[2]);

            int currentMove = d;
            int movesCount = 0;

            int maxX = 0,
                maxY = 0,
                minX = 0,
                minY = 0;

            List<Cell> markedCells = new List<Cell>();

            while (movesCount < n)
            {
                if (movesCount > n)
                    break;

                for (int i = 0; i < currentMove; i++)
                {
                    movesCount++;
                    curX++;
                    markedCells.Add(new Cell(curX, curY));
                    if (curX > maxX)
                        maxX = curX;
                    if (movesCount > n)
                        break;
                }

                if (movesCount > n)
                    break;

                for (int i = 0; i < currentMove; i++)
                {
                    movesCount++;
                    curY--;
                    markedCells.Add(new Cell(curX, curY));
                    if (curY < minY)
                        minY = curY;
                    if (movesCount > n)
                        break;
                }

                if (movesCount > n)
                    break;

                currentMove *= k;

                for (int i = 0; i < currentMove; i++)
                {
                    movesCount++;
                    curX--;
                    markedCells.Add(new Cell(curX, curY));
                    if (curX < minX)
                        minX = curX;
                    if (movesCount > n)
                        break;
                }

                if (movesCount > n)
                    break;

                for (int i = 0; i < currentMove; i++)
                {
                    movesCount++;
                    curY++;
                    markedCells.Add(new Cell(curX, curY));
                    if (curY > maxY)
                        maxY = curY;
                    if (movesCount > n)
                        break;
                }

                if (movesCount > n)
                    break;

                currentMove *= k;
            }

            int rectSizeX = maxX - minX + 1;
            int rectSizeY = maxY - minY + 1;

            Console.WriteLine(rectSizeX + " " + rectSizeY);

            bool end = false;
            for (int x = minX; x < maxX + 1; x++)
            {
                for (int y = minY; y < maxY + 1; y++)
                {
                    for (int i = 0; i < markedCells.Count; i++)
                    {
                        if (markedCells[i].x == y && markedCells[i].y == x)
                        {
                            Console.Write("*");
                            end = true;
                            break;
                        }
                    }

                    if (end == false)
                        Console.Write(".");

                    end = false;
                }

                Console.WriteLine();
            }
        }
    }
}