#include <iostream>
#include <set>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;

#define ll long long
#define vii vector<int>
#define pii pair<int, int>
#define ld long double
#define s second
#define f first
#define mp make_pair
int hStart, hEnd, wStart, wEnd;

void check(pii cur)
{
    hStart = min(hStart, cur.s);
    hEnd = max(hEnd, cur.s);
    wStart = min(wStart, cur.f);
    wEnd = max(wEnd, cur.f);
}

void mov(pii& cord, int dir)
{
    if(dir == 1)
        cord.f++;
    if(dir == 2)
        cord.s--;
    if(dir == 3)
        cord.f--;
    if(dir == 4)
        cord.s++;

    check(cord);
}

int main()
{
    int n, d, k;
    vector<vector<bool> > field(3000, vector<bool>(3000));

    cin >> n >> d >> k;
    hStart = 1500, hEnd = 0;
    wStart = 1500, wEnd = 0;

    int dir = 1;
    pii cord = mp(1500, 1500);
    field[cord.f][cord.s] = 1;
    bool was = 0;

    while(true)
    {
        bool en = 0;

        for(int j = 0; j < d; j++)
        {
            mov(cord, dir);
            n--;
            field[cord.f][cord.s] = 1;
            if(n == 0)
            {
                en = 1;
                break;
            }
        }
        if(en)
            break;
        dir++;
        if(dir == 5)
            dir = 1;

        for(int j = 0; j < d; j++)
        {
            mov(cord, dir);
            n--;
            field[cord.f][cord.s] = 1;
            if(n == 0)
                en = 1;
        }
        if(en)
            break;

        dir++;
        if(dir == 5)
            dir = 1;

        if(!was)
        {
            was = 1;
            d *= k;
        }
    }
    cout << hEnd - hStart + 1 << " " << wEnd - wStart + 1 << endl;
    for(int i = hStart; i <= hEnd; i++)
    {
        for(int j = wStart; j <= wEnd; j++)
        {
            if(field[j][i])
                cout << "*";
            else
                cout << ".";
        }
        cout << endl;
    }
    return 0;
}
