#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <deque>

#define fi first
#define se second

typedef long long LL;
typedef long double LD;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif

using namespace std;

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int k, n;
	cin >> k >> n;
	vector<vector<int>> p(k, vector<int> (k, 0));
	for (int i = 0; i < n; i++) {
		char x, y;
		cin >> x >> y;
		p[x - 'a'][y - 'a'] = 1;
		p[y - 'a'][x - 'a'] = 1;
	}
	string s, t;
	cin >> s >> t;
	n = s.size();
	for (int i = 0; i < n; i++){
		if (s[i] == t[i]){
			continue;
		} else {
			int r = i;
			while(s[r] != t[i] && r < n) r++;
			if(r >= n) {
				cout << "NO" << endl;
				return 0;
			}
			for (int j = r - 1; j >= i; j--) {
				if(!p[s[j]-'a'][s[j+1]-'a']) {
					cout << "NO" << endl;
					return 0;
				}
				swap(s[j], s[j + 1]);
			}
		}
	}
	cout << "YES";
	return 0;
}