#include <iostream>
using namespace std;
long long gcd (long long a, long long b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}
long long a[2000001];
void add(long long pos) {
    if (pos == 0) return;
    a[pos] = gcd(a[pos * 2], a[pos * 2 + 1]);
    if (pos == 0) return;
    add(pos / 2);
}
long long findlr(long long l, long long r, long long cl, long long cr, long long pos) {
    //cout << l << " " << r << " " << cl << " " << cr << " " << pos << "\n";
    if (cl >= r || cr <= l) return 0;
    if (l == cl && r == cr) {
        return a[pos];
    }
    long long m = (cl + cr) / 2;
    if (m > r) return findlr(l, r, cl, m, pos * 2);
    if (m <= l) return findlr(l, r, m, cr, pos * 2 + 1);
    return gcd(findlr(l, m, cl, m, pos * 2), findlr(m, r, m, cr, pos * 2 + 1));
}
int main() {
    //freopen("stdin", "r", stdin);
    long long n, k;
    cin >> n >> k;
    long long pow2 = 1;
    while (pow2 < n) {
        pow2 *= 2;
    }
    long long x;
    for (long long i = pow2; i < pow2 + n; i++) {
        cin >> a[i];
    }
    for (long long i = pow2; i < pow2 + n; i++) {
        add(i / 2);
    }
    //numeration is from 1
    long long maxg;
    for (long long i = 0; i < n - k; i++) {
        long long const1 = findlr(i, i + k, 0, pow2, 1);
        if (const1 > maxg) maxg = const1;
    }
    cout << maxg;
}
/*
10 4
2 3 4 8 12 6 12 18 4 3
*/
