#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

long long gcd(long long x, long long y) {
    if (x == 0) return y;
    if (x > y) {
        return gcd(x % y, y);
    } else {
        return gcd(y % x, x);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (n > 100) {
        long long ans = 1;
        for (int x = 1; x <= 100; x++) {
            int cnt = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i] % x == 0) {
                    cnt++;
                    if (cnt >= k) break;
                } else {
                    cnt = 0;
                }
            }
            if (cnt >= k) ans = x * 1ll;
        }
        cout << ans << endl;
        return 0;
    }
    long long ans = 0;
    for (int j = 0; j < n - k + 1; ++j) {
        long long tmp = 0;
        tmp = a[j];
        for (int i = j + 1; i < j + k; ++i) {
            tmp = gcd(tmp, a[i]);
        }
        ans = max(tmp, ans);
    }
    cout << ans << endl;
//    int cnt = 0;
//    if (t == 1) {
//        if (n % 2 == 1) {
//            for (int i = 0; i < n - 3; ++i) {
//                if (i % 2 == 0) cout << i + 2 << " ";
//                else cout << i << " ";
//            }
//            cout << n - 1 << " " << n << " " << n - 2 << endl;
//        } else {
//            for (int i = 0; i < n; ++i) {
//                if (i % 2 == 0) cout << i + 2 << " ";
//                else cout << i << " ";
//            }
//            cout << endl;
//        }
//        return 0;
//    }
//    while (next_permutation(a.begin(), a.end()) && cnt < t) {
//        bool f = true;
//        for (int i = 0; i < n; ++i) {
//            if (a[i] == i + 1) {
//                f = false;
//                break;
//            }
//        }
//        if (f) {
//            cnt++;
//            for (int i = 0; i < n; ++i) {
//                cout << a[i] << " ";
//            }
//            cout << endl;
//        }
//    }
    return 0;
}