#include <cstdio>
#include <cstdlib>

int *m, n;

void Swap( int *a, int *b )
{
  int t = *a;

  *a = *b;
  *b = t;
}

void Sort( int *m, int n )
{
  int b = 0, e = n - 1, x;

  if (n < 2)
    return;
  x = m[n / 2];

  while (b <= e)
  {
    while (m[b] < x)
      b++;
    while (m[e] > x)
      e--;

    if (b <= e)
    {
      Swap(m + b, m + e);
      b++;
      e--;
    }
  }

  Sort(m, e);
  Sort(m + b, n - b);
}

void Change( void )
{
  int st = 0, max = 0;

  for (int i = 0; i < n - 1; i++)
    if (m[i] < m[i + 1])
    {
      st = i;
      max = i + 1;
    }
    else if (m[i + 1] < m[max] && m[i + 1] > m[st])
      m[max] = m[i + 1];

  Swap(m + st, m + max);
  Sort(m + st + 1, n - st - 1);
}

int main( void )
{
  int *tt, t, i, now, dyn = 0;

  scanf("%i%i", &n, &t);
  m  = (int *)malloc(sizeof(int) * n);
  tt = (int *)malloc(sizeof(int) * t * n);

  for (i = 0; i < n; i++)
    m[i] = i + 1;
  m[0] = 2, m[1] = 1;
  for (now = 1, i = 1; i <= n; i++)
    now *= i;

  while (dyn < t)
  {
    int f = 1;
    for (i = 0; i < n; i++)
      if (m[i] == i + 1)
      {
        f = 0;
        break;
      }
    if (f)
    {
      for (i = 0; i < n; i++)
        tt[dyn * n + i] = m[i];
      dyn++;
    }

    Change();
  }

  for (dyn = 0; dyn < t; dyn++)
    for (i = 0; i < n; i++)
      printf("%i%c", tt[dyn * n + i], (i == n - 1 ? '\n' : ' '));

  return 0;
}