from math import sqrt
from math import floor


def f(a):
    return a * (2 * a + 1) * (a + 1) // 6


def bin_search(a):
    left = 1
    right = int(floor(sqrt(a)))
    while right - left > 1:
        m = (right + left) // 2
        if f(m) > a:
            right = m
        else:
            left = m
    return left


n = int(input())
print(bin_search(n))