/*  */

#include <iostream>
//#include <cmath>

using namespace std;

long long Min( long long a, long long b )
{
  return a < b ? a : b;
}

long long Max( long long a, long long b )
{
  return a > b ? a : b;
}

long long MinArr( long long *a, int size )
{
  long long min = 1e18;
  for (int i = 0; i < size; i++)
    min = Min(min, a[i]);
  return min;
}

long long MaxArrD( long long *a, int size )
{
  long long maxd = 1, minnum = MinArr(a, size);
  for (long long j = 1; j <= minnum; j++)
  {
    bool IsD = true;
    for (int i = 0; i < size; i++)
      if (a[i] % j != 0)
        IsD = false;
    if (IsD)
      maxd = Max(j, maxd);
  }

  return maxd;
}

long long GreatD( long long *a, int size, int k )
{
  long long MaxD = 1;
  for(int i = 0; i < size - k + 1; i++)
    MaxD = Max(MaxD, MaxArrD(a + i, k));
  return MaxD;
}

int main( void )
{
  int n, k;
  long long A[50000];

  cin >> n >> k;
  for (int i = 0; i < n; i++)
    cin >> A[i];

  cout << GreatD(A, n, k);
  //cout <<"OK";

  system("pause");

  return 0;
}