#include <iostream>
#include <cmath>
#include <cstring>

using namespace std;

int k;

unsigned long long FindMax( unsigned long long *A )
{
  unsigned long long M = A[0];

  for (int i = 0; i < k; i++)
    if (M < A[i])
      M = A[i];
  return M;
}

unsigned long long MaxDiv( unsigned long long *A )
{
  unsigned long long MaxDiv = 1, Max = FindMax(A);

  for (unsigned long long i = Max; i >= 2; i--)
  {
    int flag = 1;
      for (int j = 0; j < k; j++)
        if (A[j] % i != 0)
        {
          flag  = 0;
          break;
        }

    if (flag == 1)
    {
      MaxDiv = i;
      break;
    }
  }

  return MaxDiv;
}

int main( void )
{
  int n;

  cin >> n >> k;

  unsigned long long *A  = new unsigned long long[n], Ans = 1;

  for (int i = 0; i < n; i++)
    cin >> A[i];

  for (int i = 0; i < n - k + 1; i++)
  {
    unsigned long long d = MaxDiv(&(A[i]));

    if (d > Ans)
      Ans = d;
  }

  cout << Ans;
}