#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;

long long gcd(long long a, long long b) {

    if(a == 0 || b == 0) return a + b;
    return gcd(b, a % b);

}

vector < long long > tree;

long long get_ans(int v, int l, int r, int vl, int vr) {

    if(vr <= l || r <= vl) return 0;
    if(vl <= l && r <= vr) return tree[v];
    int m = (r + l) / 2;
    return gcd( get_ans(v * 2, l, m, vl, vr), get_ans(v * 2 + 1, m, r, vl, vr));

}

int main() {
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    int N = 1;
    while(N < n) N *= 2;
    tree = vector < long long > (2 * N, 0);
    vector < long long > a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        tree[N + i] = a[i];
    }
    for (int i = N - 1; i > 0; i--) tree[i] = gcd(tree[2 * i], tree[2 * i + 1]);
    long long ans = 0;
    for (int i = 0; i <= n - k; i++) {
        ans = max(ans, get_ans(1, 0, N, i, i + k));
    }
    cout << ans << endl;
}
