#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;


int main()
{

    int k, n;
    cin >> k >> n;
    vector<vector<int> > a(k, vector<int> (k, 0));
    for (int i = 0; i < n; i++)
    {
        char x, y;
        cin >> x >> y;
        a[x - 'a'][y - 'a'] = 1;
        a[y - 'a'][x - 'a'] = 1;
    }
    string s, t;
    cin >> s >> t;
    vector<int> ss[k];

    int L = s.size();
    vector< vector<int> > prefs(k, vector<int>(L + 1, 0));
    for (int i = 0; i < k; i++)
    {
        ss[i].push_back(0);
    }

    for (int i = 1; i <= L; i++)
    {
        ss[s[i - 1] - 'a'].push_back(i);
        for (int j = 0; j < k; j++)
        {
            prefs[j][i] = prefs[j][i - 1];
        }
        prefs[s[i - 1] - 'a'][i]++;
    }

    vector<int> tt[k];

    for (int i = 0; i < k; i++)
    {
        tt[i].push_back(0);
    }

    vector< vector<int> > preft(k, vector<int>(L + 1, 0));

    for (int i = 1; i <= L; i++)
    {
        tt[t[i - 1] - 'a'].push_back(i);
        for (int j = 0; j < k; j++)
        {
            preft[j][i] = preft[j][i - 1];
        }
        preft[t[i - 1] - 'a'][i]++;
    }


    for (int i = 0; i < k; i++)
    {
        if (ss[i].size() != tt[i].size())
        {
            cout << "NO";
            return 0;
        }
    }

    for (int i = 0; i < k; i++)
    {
        for (int j = 1; j < ss[i].size(); j++)
        {
            int cur = ss[i][j];
            int pred = ss[i][j - 1];

            for (int u = 0; u < k; u++)
            {
                if (i == u) continue;
                if (a[i][u] == 0)
                {
                    int h = prefs[u][cur] - prefs[u][pred];
                    int g = preft[u][tt[i][j]] - preft[u][tt[i][j - 1]];
                    if (h != g)
                    {
                        cout << "NO";
                        return 0;
                    }
                }
            }
        }
    }
    cout << "YES";


}


/*
3 2
ab
bc
abbcabc
abcacbb



3 2
ab
bc
abbcabc
aabbbcc
*/

