#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

long long nod(long long a, long long b) {
	if (a > b) swap(a, b);
	if (a == b) return a;
	long long otv = 1;
	for (long long q = 1; q <= sqrt(a); q++) {
		if (a % q == 0) {
			if (b % q == 0) otv = q;
			if (b % (a / q) == 0) return a / q;
		}
	}
	return otv;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	long long n, k, ma = 1;
	cin >> n >> k;
	vector <vector <long long> > a(n, vector <long long>(n));
	for (int i = 0; i < n; i++) {
		cin >> a[i][i];
	}
	long long q = 0;
	while (k > 1) {
		for (int i = 0; i < n - q - 1; i++) {
			a[i][i + 1 + q] = nod(a[i][i + q], a[i + 1][i + 1 + q]);
			if (k == 2) {
				ma = max(ma, a[i][i + 1 + q]);
			}
		}
		k--;
		q++;
	}
	cout << ma;
	return 0;
}