#include <iostream>
#include <algorithm>
using namespace std;

void first_perm_sorted(int *mas, int n){
    for(int i=0; i<n; i+=2){
        if(i + 1 < n){
            swap(mas[i], mas[i + 1]);
        }
    }
    if(n % 2 == 1)
        swap(mas[n - 2], mas[n - 1]);
}
void next_perm(int *mas, int n){
    int j = n - 2;
    while (j != -1 && mas[j] > mas[j + 1])
        j--;
    int k = n - 1;
    while (mas[j] > mas[k] || mas[k] == j)
        k--;
    swap(mas[k], mas[j]);
    reverse(mas + j + 1, mas + n);
    first_perm_sorted(mas + j + 1, n - j - 1);
}
int main(){
    int n, t;
    cin >> n >> t;
    int mas[n];
    for(int i=0; i<n; i++)
        mas[i] = i;
    first_perm_sorted(mas, n);
    bool do_next = false;
    for(int k=0; k<t; k++){
        if(do_next)
            next_perm(mas, n);
        do_next = true;
        for(int i=0; i<n; i++)
            cout << mas[i] + 1 << " ";
        cout << "\n";
    }
    return 0;
}
