#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
	const int SIZE = 2005;
	int n, d, k, x, y, min_x, min_y, max_x, max_y, cnt, add_x, add_y;
	static bool field[SIZE][SIZE], incr;

	cin >> n >> d >> k;
	min_x = max_x = min_y = max_y = x = y = 1001;
	cnt = 0;
	add_x = 1;
	add_y = 0;
	field[x][y] = 1;
	for (int step = 0; step < n; step++)
	{
		cnt++;
		x += add_x;
		y += add_y;
		max_x = max(max_x, x);
		min_x = min(min_x, x);
		max_y = max(max_y, y);
		min_y = min(min_y, y);
		field[y][x] = 1;
		if (cnt == d)
		{
			cnt = 0;
			if (incr)
				d *= k;
			incr ^= 1;
			if (add_x == 1 && add_y == 0)
			{
				add_x = 0;
				add_y = -1;
			}
			else if (add_x == 0 && add_y == -1)
			{
				add_x = -1;
				add_y = 0;
			}
			else if (add_x == -1 && add_y == 0)
			{
				add_x = 0;
				add_y = 1;
			}
			else
			{
				add_x = 1;
				add_y = 0;
			}
		}
	}
	cout << max_y - min_y + 1 << ' ' << max_x - min_x + 1 << endl;
	for (int i = min_y; i <= max_y; i++)
	{
		for (int j = min_x; j <= max_x; j++)
			if (field[i][j])
				cout << '*';
			else
				cout << '.';
		cout << endl;
	}
}