#include <iostream>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	const int SIZE = 1e5 + 1, ALPH = 15;
	static int k, n, l, cnt[SIZE][ALPH], used[ALPH], next_entry[ALPH][SIZE], curr, outp_cnt[ALPH];
	static bool can_swap[ALPH][ALPH];
	char a, b;
	string inp, outp;

	cin >> k >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a >> b;
		can_swap[a - 'a'][b - 'a'] = can_swap[b - 'a'][a - 'a'] = 1;
	}
	for (int i = 0; i < k; i++)
		can_swap[i][i] = 1;
	cin >> inp >> outp;
	l = inp.size();
	for (int i = 0; i < l; i++)
	{
		inp[i] -= 'a';
		outp[i] -= 'a';
	}
	for (int i = 0; i < l; i++)
		outp_cnt[outp[i]]++;
	for (int i = 0; i < l; i++)
	{
		next_entry[inp[i]][used[inp[i]]] = i;
		used[inp[i]]++;
	}
	cnt[0][inp[0]]++;
	for (int i = 1; i < l; i++)
	{
		for (int j = 0; j < k; j++)
			cnt[i][j] = cnt[i - 1][j];
		cnt[i][inp[i]]++;
	}
	/*for (int i = 0; i < k; i++)
	{
		cout << i << ": ";
		for (int j = 0; j < used[i]; j++)
			cout << next_entry[i][j] << ' ';
		cout << endl;
	}*/
	for (int i = 0; i < k; i++)
		if (used[i] != outp_cnt[i])
		{
			cout << "NO";
			return 0;
		}
	for (int i = 0; i < k; i++)
		used[i] = 0;
	for (int i = 0; i < l; i++)
	{
		//cout << (int)(inp[i]) << ' ' << (int)(outp[i]) << ' ' << used[outp[i]] << endl;
		curr = next_entry[outp[i]][used[outp[i]]];
		//cout << curr << endl;
		if (curr == i)
		{
			used[outp[i]]++;
			continue;
		}
		for (int j = 0; j < k; j++)
		{
			//if (cnt[curr - 1][j] - used[j] > 0)
			//	cout << i << ' ' << outp[i] << ' ' << j << endl;
			if (cnt[curr - 1][j] - used[j] > 0 && !can_swap[j][outp[i]])
			{
				cout << "NO";
				return 0;
			}
		}
		used[outp[i]]++;
	}
	cout << "YES";
}