#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

vector<long long> t(4000001);
vector<long long> a(1000001);

long long gecd(long long a, long long b){
    return b==0 ? a : gecd(b, a%b);
}

void build(long long v, long long tl, long long tr){
    if(tl==tr) t[v] = a[tl];
    else {
        long long tm = (tl+tr)/2;
        build(v*2, tl, tm);
        build(v*2+1, tm+1, tr);
        t[v] = gecd(t[v*2], t[v*2+1]);
    }
}

long long gcd(long long v, long long tl, long long tr, long long l, long long r){
    if(l>r)
        return 0LL;
    if(l==tl&&r==tr)
        return t[v];
    long long tm = (tr+tl)/2;
    return gecd(gcd(v*2, tl, tm, l, min(r, tm)), gcd(v*2+1, tm+1, tr, max(l, tm+1), r));
}

int main(){
    long long n, k, maxi=0, t;
    scanf("%lld %lld", &n, &k);
    for(int i=0; i<n; i++){
        scanf("%lld", &a[i]);
    }
    build(1, 0, n-1);
    for(int i=0; i+k-1<n; i++){
        t = gcd(1, 0, n-1, i, i+k-1);
        if(t>maxi) maxi = t;
    }
    printf("%lld", maxi);
}
