
#include <iostream>
#include <vector>
using namespace std;
unsigned long long gcd(unsigned long long a, unsigned long long b){
    return b == 0? a : gcd(b, a%b);
}
void tree(unsigned long long a[], unsigned long long t[], int v, int l, int r){
    if(l == r){
        t[v] = a[r];
    }
    else{
        int mid = (l+r)/2;
        tree(a, t, v*2, l, mid);
        tree(a, t, v*2+1, mid + 1, r);
        t[v] = gcd(t[v*2], t[v*2+1]);
    }
}
unsigned long long get_gcd(unsigned long long t[], int v, int tl, int tr, int l, int r){
    if(l > r){
        return 0;
    }
    if(l == tl && r == tr){
        return t[v];
    }
    int mid = (tl + tr) / 2;
    return gcd(get_gcd(t, v*2, tl, mid, l, min(r, mid)),get_gcd(t, v*2+1, mid + 1, tr, max(l, mid + 1), r ));
}


int main(){
    int n, k;
    cin >> n >> k;
    unsigned long long a[n] = {0};
    unsigned long long t[n*4]={0};
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    tree(a,t, 1, 0, n - 1);
    if(n == k){
        cout << get_gcd(t, 1, 0, n - 1, 0, k - 1);
        return 0;
    }
    int l = 0;
    unsigned long long max_gcd = 1;
    while(l <= n - k){
       unsigned long long temp = get_gcd(t, 1, 0, n - 1, l, l + k - 1);
       if(temp > max_gcd){
           max_gcd = temp;
       }
       l++;
    }
    cout << max_gcd;



    return 0;

}
