
import java.util.*;
import java.io.*;

public class Main {
    FastScanner in;
    PrintWriter out;

    public void solve() {
        int n = in.nextInt();
        long k = in.nextInt();
        long[] mas = new long[n];
        int sum = 0;
        long max = 0;
        ArrayList<Long> l = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            mas[i] = in.nextInt();
            l.add(mas[i]);
            if (l.size() == k) {
                long ll = del(l.toArray());
                if (ll > max) {
                    max = ll;
                }
                l.remove(0);
            }
        }
        out.println(max);
    }

    private long del(Object[] a) {
        long nod = 0;
        for (int i = 0; i < a.length; i++) { //Нахождение НОД всех чисел массива
            if (i + 1 < a.length) {
                for (int j = i + 1; j <= i + 1; j++) {
                    nod = gcd(a[i], a[j]);
                }
                a[i + 1] = nod;
            }
        }
        return nod;
    }

    public long gcd(Object a, Object b) {
        while ((long) b != 0) {
            long tmp = (long) a % (long) b;
            a = b;
            b = tmp;
        }
        return (long) a;
    }

    public void run() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] arg) {
        new Main().run();
    }
}