#include <iostream>
#include <set>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;

#define ll long long
#define vii vector<int>
#define pii pair<int, int>
#define ld long double
#define s second
#define f first
#define mp make_pair

ll gcd(ll a, ll b)
{
    if(b == 0)
        return a;
    else
        return gcd(b, a % b);
}

int main()
{
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    vector<vector<int> > dp(n, vector<ll>(k + 1));

    for(int i = 0; i < n; i++)
        dp[i][1] = a[i];

    for(ll len = 2; len <= k; len++)
    {
        for(ll x = 0; x <= n - k; x++)
        {
            dp[x][len] = max(dp[x][len], gcd(dp[x][len - 1], dp[x + len - 1][1]));
        }
    }
    ll answ = 0;
    for(int i = 0; i <= n - k; i++)
        answ = max(answ, dp[i][k]);
    cout << answ << endl;
    return 0;
}
