#include <iostream>

void swap(int *a, int i, int j) {
    a[i] += a[j];
    a[j] = a[i] - a[j];
    a[i] -= a[j];
}

bool next(int *a, int n) {
    int j = n - 2;
    while(j != -1 && a[j] >= a[j + 1]) j--;
    if (j == -1) return false;
    int k = n - 1;
    while (a[j] >= a[k]) k--;
    swap(a, j, k);
    int l = j + 1, r = n - 1;
    while (l < r) swap(a, l++, r--);
    return true;
}

int main() {
    int n, *a, t, i = 0;
    std::cin >> n >> t;
    a = new int[n];
    for(int i = 0; i < n; i++) {
        a[i] = i + 1;
    }
    do {
        for(int i = 0; i < n; i++) {
            if(a[i] == i) goto c;
        }
        for(int i = 0; i < n; i++) {
            std::cout << a[i] << " ";
        }
        std::cout << "\n";
        c:
        i++;
    } while(next(a, n) && i < t);
    return 0;
}