#include <iostream>
#include <vector>

typedef std::vector<int> T_ints;

int getmcd(T_ints ints) {
    int a = ints.back();
    ints.pop_back();
    int b = ints.back();
    ints.pop_back();
    while(a != b) {
        if(a > b) a -= b;
        else b -= a;
    }
    if(ints.size() == 0) {
        return a;
    }
    ints.push_back(a);
    return getmcd(ints);
}

int main()
{
    int n, k;
    std::cin >> n >> k;
    int a[n];
    for(int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    int max = 0;
    for(int i = 0; i <= n - k; i++) {
        T_ints list;
        for(int j = i; j < i + k; j++) {
            list.push_back(a[j]);
        }
        int mcd = getmcd(list);
        if(mcd > max) max = mcd;
    }
    std::cout << max;
}