#include <iostream>
#include <vector>

typedef std::vector<int> T_ints;

int getmcd2(int a, int b) {
    if(a == 0L) return b;
    if(b == 0L) return a;
    if(a == b) return a;
    if(a == 1L || b == 1L) return 1L;
    if(a % 2L == 0L && b % 2L == 0L) return 2L * getmcd2(a / 2L, b / 2L);
    if(a % 2L == 0L && b % 2L != 0L) return getmcd2(a / 2L, b);
    if (a % 2L != 0L && b % 2L == 0L) return getmcd2(a, b / 2L);
    if (a < b) return getmcd2((b - a) / 2L, a);
    else return getmcd2((a - b) / 2L, b);
}

int getmcd(T_ints ints) {
    int a = ints.back();
    ints.pop_back();
    int b = ints.back();
    ints.pop_back();
    ints.push_back(getmcd2(a, b));
    return getmcd(ints);
}

int main()
{
    int n, k;
    std::cin >> n >> k;
    int a[n];
    for(int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    int max = 0;
    for(int i = 0; i <= n - k; i++) {
        T_ints list;
        for(int j = i; j < i + k; j++) {
            list.push_back(a[j]);
        }
        int mcd = getmcd(list);
        if(mcd > max) max = mcd;
    }
    std::cout << max;
}