#include <iostream>
#include <vector>
#include <cmath>

#define fi first
#define se second

typedef long long LL;
typedef long double LD;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif

using namespace std;

LL bcd(LL a, LL b){
	LL t = a;
	a = max(a,b);
	b = min(t,b);
	while(b > 0) {
		LL q = a;
		a = max(b, a%b);
		b = q % b;
	}
	return a;
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	LL n, k, mk = 0;
	cin >> n >> k;
	vector<LL> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n - k+1; i++) {
		LL t = a[i];
		for(int j = i + 1; j < i + k; j++) {
			t = bcd(t, a[j]);
		}
		if(t > mk){
			mk = t;
		}
	}
	cout << mk << endl;
	return 0;
}