uses
  Math;

type
  Direction = (right, up, left, down);

var
  i,j, n, d, k, d_, cl, cu, cd, cr:Int32;
  x, y: Int32;
  Direct: Direction;
  Field: array [1..10000, 1..10000] of Char;


begin
  ReadLn(n, d, k);
  For i := 1 to 10000 do
    For j := 1 to 10000 do
      Field[i, j] := '.';
  x := 5000;
  y := 5000;
  Field[x, y] := '*';
  d_ := d;
  Direct := left;

  While n > 0 do
  begin
    If d_ = 0 then
    begin
      Case Direct of
      right: Direct := up;
      up: begin Direct := left;  d := d * k; end;
      left: Direct := down;
      down: begin Direct := right; d := d * k; end;
      end;
      d_ := d;
    end;
    Case Direct of
      right: x += 1;
      up: y += 1;
      left: x -= 1;
      down: y -= 1;
    end;
    n -= 1;
    d_ -= 1;
    Field[x, y] := '*';
  end;
  cl := 10000;
  cu := 10000;
  cr := 1;
  cd := 1;
  For i := 1 to 10000 do
    For j := 1 to 10000 do
      begin
        If Field[i, j] = '*' then cl := min(cl, i);
        If Field[i, j] = '*' then cu := min(cu, j);
        If Field[i, j] = '*' then cr := max(cr, i);
        If Field[i, j] = '*' then cd := max(cd, j);
      end;
  WriteLn(cd - cu + 1, ' ', cr - cl + 1);
  For i := cu to cd do
  begin
    For j := cr downto cl do
    begin
      Write(Field[j, i]);
    end;
    WriteLn;
  end;
  ReadLn;
end.
