import java.util.Scanner;
import static java.lang.Math.*;

public class TaskBSquares {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		long n = sc.nextLong();
		System.out.println(think(n));
	}

	private static long think(long n) {
		for (long x = findFloorLimit(n) - 2; true; x++) {
			if ((x * (x + 1) * (2 * x + 1) / 6) >= n) {
				return x - 1;
			}
		}
	}

	private static long findFloorLimit(long n) {
		// In fact, x(x+1)(2x+1)/6 <n; max N  x
		// So, it will be 2xxx+3xx+x-6n will be = 0 for easy counting
		// I think, that is ... but wCube = 3n; so x = (3n)^1/3 + 1/(12(3n)^1/3)
		// - 1/2
		double t = pow(n * 3, 1d / 3d);
		long x = (long) (t + 1d / (12d * t) - 1d / 2d);
		return x;
	}

}
