import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Scanner;

import static java.lang.Math.*;

public class TaskC {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		int n,d,k;
		n = sc.nextInt();
		d = sc.nextInt();
		k = sc.nextInt();
		
		think(n,d,k, System.out);
	}

	private static void think(int n, int d, int k, PrintStream out) {
		int v = 0; //0-right, 1-up, 2-left, 3-down
		int curx = 0;
		int cury = 0;
		int iter = 0;
		ArrayList<Point> passed = new ArrayList<>();
		int minx = 0;
		int miny = 0;
		int maxx = 0;
		int maxy = 0;
		passed.add(new Point(curx, cury));
		out: while (true){
			for (int i = 0; i < d; i++) {
				switch (v%4) {
				case 0:
					curx++;
					break;
				case 1:
					cury++;
					break;
				case 2:
					curx--;
					break;
				case 3:
					cury--;
					break;
				}
				minx = min(minx,curx);
				miny = min(miny,cury);
				maxx = max(maxx,curx);
				maxy = max(maxy,cury);
				passed.add(new Point(curx, cury));
				iter++;
				if(iter>=n)
					break out;
			}
			
			v++;
			
			for (int i = 0; i < d; i++) {
				switch (v%4) {
				case 0:
					curx++;
					break;
				case 1:
					cury--;
					break;
				case 2:
					curx--;
					break;
				case 3:
					cury++;
					break;
				}
				minx = min(minx,curx);
				miny = min(miny,cury);
				maxx = max(maxx,curx);
				maxy = max(maxy,cury);
				passed.add(new Point(curx, cury));
				iter++;
				if(iter>=n)
					break out;
			}
			
			v++;
			
			d*=k;
		}
		
		boolean[][] chars = new boolean[maxx-minx+1][maxy-miny+1];
		for(Point p : passed){
			int x = p.x-minx;
			int y = p.y-miny;
			chars[x][y]=true;
		}
		
		out.println(""+(maxy-miny+1)+" "+(maxx-minx+1));
		for(int i =0; i< (maxy-miny+1); i++){
			for(int j =0; j< (maxx-minx+1); j++){
				out.print(chars[j][i]?'*':'.');
			}
			out.println();
		}
	}

	private static class Point{
		public Point(int x, int y) {
			super();
			this.x = x;
			this.y = y;
		}

		int x,y;
	}
}
