class SparseTable():
    def __init__(self, a):
        self.a = a
        self.n = len(a)
        self.lg = [0 for i in range(self.n + 1)]
        self.last = 1
        for i in range(1, self.n + 1):
            if (i == (1 << self.last)):
                self.lg[i] = self.lg[i - 1] + 1
                self.last += 1
            else:
                self.lg[i] = self.lg[i - 1]
        self.dp = [[float('inf') for j in range(self.lg[self.n] + 1)] for i in range(self.n + 1)]
        for j in range(self.lg[self.n] + 1):
            for i in range(self.n):
                if j == self.lg[0]:
                    self.dp[i][j] = self.a[i]
                else:
                    if i + (1 << (j - 1)) > self.n:
                        pass
                    else:
                        self.dp[i][j] = gcd(self.dp[i][j - 1], self.dp[i + (1 << (j - 1))][j - 1])

    def find(self, l, r):
        return gcd(self.dp[l][self.lg[r - l]], self.dp[r - (1 << self.lg[r - l])][self.lg[r - l]])

def gcd(a, b):
    a, b = max(a, b), min(a, b)
    if b == 0:
         return a
    return gcd(b, a % b)
n, k = map(int, input().split())
a = [int(t) for t in input().split()]
sparse_table = SparseTable(a)
ans = float('-inf')
for i in range(n - k - 1):
    ans = max(ans, sparse_table.find(i, i + k))
print(ans)