#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int INF = 1e9;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, d, k;
	cin >> n >> d >> k;
	vector<vector<char>> a(n * 3, vector<char>(n * 3, '.'));
	int x = n, y = n;
	a[x][y] = '*';
	int dir = 1;
	int m = n;
	while (n > 0) {
		if (dir == 0) {
			int last = x;
			for (; x > last - d && n; x--) {
				a[x - 1][y] = '*';
				n--;
			}
			dir = 3;
		}
		else if (dir == 1) {
			if (n < m)
				d *= k;
			int last = y;
			for (; y < last + d && n; y++) {
				a[x][y + 1] = '*';
				n--;
			}
			dir = 0;
		}
		else if (dir == 2) {
			int last = x;
			for (; x < last + d && n; x++) {
				a[x + 1][y] = '*';
				n--;
			}
			dir = 1;
		}
		else {
			d *= k;
			int last = y;
			for (; y > last - d && n; y--) {
				a[x][y - 1] = '*';
				n--;
			}
			dir = 2;
		}
	}
	int max_i = 0, min_i = INF;
	int max_j = 0, min_j = INF;
	for (int i = 0; i < a.size(); i++) {
		for (int j = 0; j < a[i].size(); j++) {
			if (a[i][j] == '.')
				continue;
			max_i = max(max_i, i);
			min_i = min(min_i, i);
			max_j = max(max_j, j);
			min_j = min(min_j, j);
		}
	}
	cout << max_i - min_i + 1 << " " << max_j - min_j + 1 << endl;
	for (int i = min_i; i <= max_i; i++) {
		for (int j = min_j; j <= max_j; j++) {
			cout << a[i][j];
		}
		cout << "\n";
	}
//	system("pause");
}