#include <iostream>
#include <algorithm>

using namespace std;

bool isChaos(unsigned short int* array, unsigned int size)
{
  for (unsigned short int i = 0; i < size; i++)
    if (array[i] == i + 1)
      return false;
  return true;
}

int main()
{
  unsigned short int N, t;
  cin >> N >> t;
  unsigned short int* array = new unsigned short int[N];
  for (unsigned short int i = 1; i <= N; i++)
  {
       array[i - 1] = i;
  };
  while (t > 0 && next_permutation(array, array + N))
  {
          if (isChaos(array, N))
          {
            for (unsigned short i = 0; i < N; i++)
              cout << array[i] << " ";
            t--;
          };
  };
  return 0;
}